﻿using SmartApp.Contracts.Models;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace SmartApp.Contracts.Repositories
{
    /// <summary>
    /// Provides read and write operations for heating parameters.
    /// </summary>
    public interface IParameterRepository
    {
        /// <summary>
        /// Return all existing parameters.
        /// </summary>
        /// <returns></returns>
        Task<List<ParameterHeating>> GetParameterHeatings();

        /// <summary>
        /// Save all parameters.
        /// </summary>
        /// <param name="parameterHeatings"></param>
        void SaveParameterHeatings(List<ParameterHeating> parameterHeatings);
    }
}
