﻿using System;
using Windows.Devices.Gpio;
using SmartApp.Contracts.IO;
using SmartApp.IotDevice.Modules;

namespace SmartApp.IotDevice
{
    public sealed class HeatingCentral : IHeatingCentral
    {
        #region members

        private readonly IDigitalOutputModule _digitalOutputModule0;

        #endregion

        #region constructor

        public HeatingCentral()
        {
            _digitalOutputModule0 = new DigitalOutputModule();
            _digitalOutputModule0.InitializeDevice(I2CAdresses.DigitalOutputModule0);
        }

        #endregion

        public bool CentralPump
        {
            get
            {
                // 0 -> b0
                return (_digitalOutputModule0.ReadData() & 0x01) > 0;
            }
            set
            {
                var d = _digitalOutputModule0.ReadData();
                d = value ? Convert.ToByte(d | 0x01) : Convert.ToByte(d & 0xFE);

                _digitalOutputModule0.SetData(d);
            }
        }
    }
}
