﻿using SmartApp.Contracts.IO;
using SmartApp.IotDevice.Modules;
using System;

namespace SmartApp.IotDevice
{
    public sealed class HeatingOffice : IHeatingRoom
    {
        #region members

        private readonly IDigitalOutputModule _digitalOutputModule0;

        #endregion

        #region constructor

        public HeatingOffice()
        {
            _digitalOutputModule0 = new DigitalOutputModule();
            _digitalOutputModule0.InitializeDevice(I2CAdresses.DigitalOutputModule0);
        }

        #endregion

        public bool CircuitValve
        {
            get
            {
                // 0 -> b3
                return (_digitalOutputModule0.ReadData() & 0x04) > 0;
            }
            set
            {
                var d = _digitalOutputModule0.ReadData();
                d = value ? Convert.ToByte(d | 0x04) : Convert.ToByte(d & 0xFB);

                _digitalOutputModule0.SetData(d);
            }
        }

        public double Temperature { get; set; }
        public double Humidity { get; set; }
    }
}
