﻿using System;
using SmartApp.Contracts.IO;
using SmartApp.IotDevice.Modules;

namespace SmartApp.IotDevice
{
    public class LightsEntry : ILightsEntry
    {
        #region members

        private readonly IDigitalOutputModule _digitalOutputModule1;

        private readonly IDigitalInputModule _digitalInputModule0;

        #endregion

        #region constructor
        
        public LightsEntry()
        {
            _digitalOutputModule1 = new DigitalOutputModule();
            _digitalOutputModule1.InitializeDevice(I2CAdresses.DigitalOutputModule1);

            _digitalInputModule0 = new DigitalInputModule();
            _digitalInputModule0.InitializeDevice(I2CAdresses.DigitalInputModule0);
        }

        #endregion

        public bool SwitchEntry => (_digitalInputModule0.GetData() & 0x01) > 0;

        public bool EntryColumnLight
        {
            get
            {
                // 0 -> b6
                return (_digitalOutputModule1.ReadData() & 0x40) > 0;
            }
            set
            {
                var d = _digitalOutputModule1.ReadData();
                d = value ? Convert.ToByte(d | 0x40) : Convert.ToByte(d & 0xBF);

                _digitalOutputModule1.SetData(d);
            }
        }
        public bool EntryMainLight
        {
            get
            {
                // 0 -> b7
                return (_digitalOutputModule1.ReadData() & 0x80) > 0;
            }
            set
            {
                var d = _digitalOutputModule1.ReadData();
                d = value ? Convert.ToByte(d | 0x80) : Convert.ToByte(d & 0x7F);

                _digitalOutputModule1.SetData(d);
            }
        }
    }
}
