﻿namespace SmartApp.IotDevice.Modules
{
    public class DigitalInputModule : IDigitalInputModule
    {
        #region members

        private byte _deviceId = 0;
        private GeneralI2CDevice _device;

        #endregion

        #region IDigitalInputModule
        
        public bool InitializeDevice(byte deviceId)
        {
            _deviceId = deviceId;

            _device = new GeneralI2CDevice();
            var result = _device.InitializeDeviceAsync(deviceId).Result;

            return result;
        }

        public byte GetDeviceId()
        {
            return _deviceId;
        }

        public byte GetData()
        {
            var readData = _device.ReadData();
            if (readData != null && readData.Count != 0)
            {
                return readData[0];
            }

            return 0;
        }

        #endregion
    }
}
