﻿using System.Collections.Generic;

namespace SmartApp.IotDevice.Modules
{
    public class DigitalOutputModule : IDigitalOutputModule
    {
        #region members
        
        private byte _deviceId = 0;
        private GeneralI2CDevice _device;

        #endregion

        #region IDigitalOutputModule
        
        public bool InitializeDevice(byte deviceId)
        {
            _deviceId = deviceId;

            _device = new GeneralI2CDevice();
            var result = _device.InitializeDeviceAsync(deviceId).Result;

            return result;
        }

        public byte GetDeviceId()
        {
            return _deviceId;
        }

        public byte SetData(byte data)
        {
            var dataToSend = new List<byte>() { data };
            var sendData = _device.SetData(dataToSend);

            if (sendData != null && sendData.Count != 0)
            {
                return sendData[0];
            }

            return 0;
        }

        public byte ReadData()
        {
            var readData = _device.ReadData();
            if (readData != null && readData.Count != 0)
            {
                return readData[0];
            }

            return 0;
        }

        #endregion
    }
}
