﻿using SmartApp.Contracts.IO;
using SmartApp.Contracts.Services;

namespace SmartApp.Services
{
    public sealed class LightBathService : ILightBathService
    {
        #region members
        
        private readonly ILightsBath _bathIo = null;

        #endregion

        #region constructor
        
        public LightBathService(ILightsBath bathIo)
        {
            _bathIo = bathIo;
        }

        #endregion

        #region ILightBathService

        public ILightsBath GetBathStates()
        {
            return _bathIo;
        }

        public void SwitchBalkLight(bool state)
        {
            _bathIo.BalkLight = state;
        }

        public void SwitchShowerLight(bool state)
        {
            _bathIo.ShowerLight = state;
        }

        #endregion
    }
}
