﻿using SmartApp.Contracts.IO;
using SmartApp.Contracts.Services;

namespace SmartApp.Services
{
    public sealed class LightEntryService : ILightEntryService
    {
        #region members

        private readonly ILightsEntry _lightsEntry = null;

        #endregion

        #region constructor

        public LightEntryService(ILightsEntry lightsEntry)
        {
            _lightsEntry = lightsEntry;
        }

        #endregion

        #region ILightEntryService

        public ILightsEntry GetEntryLightStates()
        {
            return _lightsEntry;
        }

        public void SwitchMainLight(bool status)
        {
            _lightsEntry.EntryMainLight = status;
        }

        public void SwitchColumnLight(bool status)
        {
            _lightsEntry.EntryColumnLight = status;
        }

        #endregion
    }
}
