﻿using SmartApp.Contracts.IO;
using SmartApp.Contracts.Services;

namespace SmartApp.Services
{
    public sealed class LightOfficeService : ILightOfficeService
    {
        #region members
        
        private readonly ILightsOffice _officeIo = null;

        #endregion

        #region constructor
        
        public LightOfficeService(ILightsOffice officeIo)
        {
            _officeIo = officeIo;
        }

        #endregion

        #region ILightOfficeService
        
        public ILightsOffice GetOfficeStates()
        {
            return _officeIo;
        }

        public void SwitchBalkLight1(bool status)
        {
            _officeIo.BalkLight1 = status;
        }

        public void SwitchBalkLight2(bool status)
        {
            _officeIo.BalkLight2 = status;
        }

        public void SwitchBalk5And6Light(bool status)
        {
            _officeIo.BalkLight5And6 = status;
        }

        public void SwitchBalk7And8Light(bool status)
        {
            _officeIo.BalkLight7And8 = status;
        }

        public void SwitchBalk9Light(bool status)
        {
            _officeIo.BalkLight9 = status;
        }

        public void SwitchBalk10Light(bool status)
        {
            _officeIo.BalkLight10 = status;
        }

        public void SwitchBalkLightUpper(bool status)
        {
            _officeIo.BalkLightUpper = status;
        }

        public void SwitchMediaboardLight(bool status)
        {
            _officeIo.MediaBoardLight = status;
        }

        public void SwitchCupboardLight(bool status)
        {
            _officeIo.CupboardLight = status;
        }

        #endregion
    }
}
