﻿using SmartApp.Contracts.Services;
using Restup.Webserver.Attributes;
using Restup.Webserver.Models.Contracts;
using Restup.Webserver.Models.Schemas;

namespace SmartApp.WebPortal
{
    [RestController(InstanceCreationType.Singleton)]
    public sealed class LightBathController
    {
        #region members
        
        private static ILightBathService _lightBathService = null;

        #endregion

        #region constructor
        
        public LightBathController()
        {
            _lightBathService = Factory.DependencyFactory.GetInstance<ILightBathService>(); 
        }

        #endregion

        #region LightBathService methods

        [UriFormat("/lightbath/bathstates")]
        public IGetResponse GetBathStates()
        {
            var states = _lightBathService.GetBathStates();

            return new GetResponse(GetResponse.ResponseStatus.OK,
                states);
        }

        [UriFormat("/lightbath/balklight/{state}")]
        public IPutResponse SwitchBalkLight(bool state)
        {
            _lightBathService.SwitchBalkLight(state);
            return new PutResponse(PutResponse.ResponseStatus.OK);
        }

        [UriFormat("/lightbath/showerlight/{state}")]
        public IPutResponse SwitchShowerLight(bool state)
        {
            _lightBathService.SwitchShowerLight(state);
            return new PutResponse(PutResponse.ResponseStatus.OK);
        }

        #endregion
    }
}
