﻿using Restup.Webserver.Attributes;
using Restup.Webserver.Models.Contracts;
using Restup.Webserver.Models.Schemas;
using SmartApp.Contracts.Services;

namespace SmartApp.WebPortal
{
    [RestController(InstanceCreationType.Singleton)]
    public sealed class LightEntryController
    {
        #region members

        private static ILightEntryService _lightEntryService = null;

        #endregion

        #region constructor

        public LightEntryController()
        {
           _lightEntryService = Factory.DependencyFactory.GetInstance<ILightEntryService>();
        }

        #endregion

        #region LightEntryService methods

        [UriFormat("/lightentry/entrylightstates")]
        public IGetResponse GetEntryLightStates()
        {
            var states =_lightEntryService.GetEntryLightStates();
            return new GetResponse(GetResponse.ResponseStatus.OK, states);
        }

        [UriFormat("/lightentry/mainlight/{state}")]
        public IPutResponse SwitchMainLight(bool state)
        {
            _lightEntryService.SwitchMainLight(state);
            return new PutResponse(PutResponse.ResponseStatus.OK);
        }

        [UriFormat("/lightentry/columnlight/{state}")]
        public IPutResponse SwitchColumnLight(bool state)
        {
            _lightEntryService.SwitchColumnLight(state);
            return new PutResponse(PutResponse.ResponseStatus.OK);
        }

        #endregion
    }
}