﻿// ************************************************************************
// Provides client connector for serverbased LightBathService.
// ************************************************************************

var LightBathService = new Object(); // namespace object

// LightBathController/getbathstates
LightBathService.GetBathStates = function () {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightbath/bathstates";

    // only for test
    var lightBathStates = LightsBathModel.LightsBath(true, true, true, true);
    defer.resolve(lightBathStates);
    // only for test

    $.getJSON(uri)
        .done(function (data) {

            var switchEntry = false;
            var switchShower = false;
            var balkLight = false;
            var showerLight = false;

            if (data.hasOwnProperty("SwitchEntry")) {
                switchEntry = data.SwitchEntry;
            }

            if (data.hasOwnProperty("SwitchShower")) {
                switchShower = data.SwitchEntry;
            }

            if (data.hasOwnProperty("BalkLight")) {
                balkLight = data.SwitchEntry;
            }

            if (data.hasOwnProperty("ShowerLight")) {
                showerLight = data.SwitchEntry;
            }

            var lightBathStates = LightsBathModel.LightsBath(switchEntry, switchShower, balkLight, showerLight);
            defer.resolve(lightBathStates);
        })
    .fail(function (ex) {
        defer.fail("Error occured during getting lightBathStates from webservice, details " + ex);
    });

    return defer.promise();
};

// LightBathController/switchbalklight/{state}
LightBathService.SwitchBalkLight = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightbath/balklight/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching bath balk light from webservice, details " + ex);
        }
    });
    return defer.promise();
};

// LightBathController//switchshowerlight/{state}
LightBathService.SwitchShowerLight = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightbath/showerlight/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching bath shower light from webservice, details " + ex);
        }
    });
    return defer.promise();
};
