﻿// ************************************************************************
// Provides client connector for serverbased LightEntryService.
// ************************************************************************

var LightEntryService = new Object(); // namespace object

// LightEntryController/getentrylightstates
LightEntryService.GetEntryLightStates = function () {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightentry/entrylightstates";

    $.getJSON(uri)
        .done(function (data) {

            var entryColumnLight = false;
            var entryMainLight = false;
            var switchEntry = false;
            
            if (data.hasOwnProperty("EntryColumnLight")) {
                entryColumnLight = data.EntryColumnLight;
            }

            if (data.hasOwnProperty("EntryMainLight")) {
                entryMainLight = data.EntryMainLight;
            }

            if (data.hasOwnProperty("SwitchEntry")) {
                switchEntry = data.SwitchEntry;
            }
            
            var lightEntryStates = LightsEntryModel.LightsEntry(entryColumnLight, entryMainLight, switchEntry);
            defer.resolve(lightEntryStates);
        })
    .fail(function (ex) {
        defer.fail("Error occured during getting lightEntryStates from webservice, details " + ex);
    });

    return defer.promise();
};

// LightEntryController/switchmainlight/{state}
LightEntryService.SwitchMainLight = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightentry/mainlight/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        data: { "state": state },
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching entry main light from webservice, details " + ex);
        }
    });
    return defer.promise();
};

// LightEntryController/switchcolumnlight/{state}
LightEntryService.SwitchColumnLight = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightentry/columnlight/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        data: { "state": state },
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching entry column light from webservice, details " + ex);
        }
    });
    return defer.promise();
};