﻿// ************************************************************************
// Provides client connector for serverbased LightOfficeService.
// ************************************************************************

var LightOfficeService = new Object(); // namespace object

// LightOfficeController/getofficestates
LightOfficeService.GetOfficeLightStates = function () {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightoffice/officestates";

    $.getJSON(uri)
        .done(function (data) {
            var balkLight1 = false;
            var balkLight2 = false;
            var balkLight5And6 = false;
            var balkLight7And8 = false;
            var balkLight9 = false;
            var balkLight10 = false;
            var balkLightUpper = false;
            var mediaBoardLight = false;
            var cupboardLight = false;
            var switchMediaboard1 = false;
            var switchMediaboard2 = false;

            if (data.hasOwnProperty("BalkLight1")) {
                balkLight1 = data.BalkLight1;
            }

            if (data.hasOwnProperty("BalkLight2")) {
                balkLight2 = data.BalkLight2;
            }

            if (data.hasOwnProperty("BalkLight5And6")) {
                balkLight5And6 = data.BalkLight5And6;
            }

            if (data.hasOwnProperty("BalkLight7And8")) {
                balkLight7And8 = data.BalkLight7And8;
            }

            if (data.hasOwnProperty("BalkLight9")) {
                balkLight9 = data.BalkLight9;
            }

            if (data.hasOwnProperty("BalkLight10")) {
                balkLight10 = data.BalkLight10;
            }

            if (data.hasOwnProperty("BalkLightUpper")) {
                balkLightUpper = data.BalkLightUpper;
            }

            if (data.hasOwnProperty("MediaBoardLight")) {
                mediaBoardLight = data.MediaBoardLight;
            }

            if (data.hasOwnProperty("CupboardLight")) {
                cupboardLight = data.CupboardLight;
            }

            if (data.hasOwnProperty("SwitchMediaboard1")) {
                switchMediaboard1 = data.SwitchMediaboard1;
            }

            if (data.hasOwnProperty("SwitchMediaboard2")) {
                switchMediaboard2 = data.SwitchMediaboard2;
            }

            var lightOfficeStates = LightsOfficeModel.LightsOffice(balkLight1, balkLight2, balkLight5And6, balkLight7And8, balkLight9, balkLight10, balkLightUpper, mediaBoardLight, cupboardLight, switchMediaboard1, switchMediaboard2);
            defer.resolve(lightOfficeStates);
        })
    .fail(function (ex) {
        defer.fail("Error occured during getting lightOfficeStates from webservice, details " + ex);
    });

    return defer.promise();
};

// LightOfficeController/switchbalklight1/{state}
LightOfficeService.SwitchBalkLight1 = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightoffice/balklight1/" + state;
    $.ajax({
        url: uri,
        type: "PUT",
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching balk 1 light from webservice, details " + ex);
        }
    });
    return defer.promise();
};

// LightOfficeController/switchbalklight2/{state}
LightOfficeService.SwitchBalkLight2 = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightoffice/balklight2/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching balk 2 light from webservice, details " + ex);
        }
    });
    return defer.promise();
};

// LightOfficeController/SwitchBalk5And6Light/{state}
LightOfficeService.SwitchBalkLight5And6 = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightoffice/balklight5And6/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching balk 5 and 6 light from webservice, details " + ex);
        }
    });
    return defer.promise();
};

// LightOfficeController/switchbalk7and8light/{state}
LightOfficeService.SwitchBalkLight7And8 = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightoffice/balklight7And8/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching balk 7 and 8 light from webservice, details " + ex);
        }
    });
    return defer.promise();
};

// LightOfficeController/switchbalklight9/{state}
LightOfficeService.SwitchBalkLight9 = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightoffice/balklight9/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching balk 9 light from webservice, details " + ex);
        }
    });
    return defer.promise();
}

// LightOfficeController/switchbalklight10/{state}
LightOfficeService.SwitchBalkLight10 = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightoffice/balklight10/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching balk 10 light from webservice, details " + ex);
        }
    });
    return defer.promise();
}

// LightOfficeController/switchbalklightupper/{state}
LightOfficeService.SwitchBalkLightUpper = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightoffice/balklightupper/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching balk upper light from webservice, details " + ex);
        }
    });
    return defer.promise();
}

// LightOfficeController/switchmediaboardlight/{state}
LightOfficeService.SwitchMediaboardLight = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightoffice/mediaboardlight/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching mediaboard light from webservice, details " + ex);
        }
    });
    return defer.promise();
}

// LightOfficeController/switchcupboardlight/{state}
LightOfficeService.SwitchCupboardLight = function (state) {
    var defer = $.Deferred();
    var uri = window.location.protocol + "//" + window.location.host + "/api/v1/lightoffice/cupboardlight/" + state;

    $.ajax({
        url: uri,
        type: "PUT",
        success: function () {
            defer.resolve();
        },
        fail: function (ex) {
            defer.fail("error occured during switching cupboard light from webservice, details " + ex);
        }
    });
    return defer.promise();
}