﻿// ************************************************************************
// Provides logic for bath room functionalities.
// ************************************************************************

var BathRoomVm = new Object(); // namespace object

// ************************************************************************
// Creates viewmodel for knockout js.
// ************************************************************************
BathRoomVm.ViewModel = function () {
    var self = this;

    self.LightsBathStates = ko.observable(LightsBathModel.LightsBath(false, false, false, false));
    self.HeatingRoomStates = ko.observable(HeatingRoomModel.HeatingRoom(false, 0.0, 0.0));

    self.SwitchBalkLight = function () {
        LightBathService.GetBathStates().then(function (lightBathStates) {
            self.LightsBathStates(lightBathStates);
            LightBathService.SwitchBalkLight(!self.LightsBathStates().BalkLight).then(function(lightBathStatesInner) {
                self.LightsBathStates(lightBathStatesInner);
            });
        });
    };

    self.SwitchShowerLight = function () {
        LightBathService.GetBathStates().then(function (lightBathStates) {
            self.LightsBathStates(lightBathStates);
            LightBathService.SwitchShowerLight(!self.LightsBathStates().ShowerLight).then(function (lightBathStatesInner) {
                self.LightsBathStates(lightBathStatesInner);
            });
        });
    };

    self.GetHeatingRoomStates = function() {
        HeatingManagementService.GetHeatingStatesBath().then(function(heatingRoomModel) {
            self.HeatingRoomStates(heatingRoomModel);
        });
    };

    // todo: timer for refreshing states
}
