﻿// ************************************************************************
// Provides logic for heating service functionalities.
// ************************************************************************

var HeatingServiceVm = new Object(); // namespace object

// ************************************************************************
// Creates viewmodel for knockout js.
// ************************************************************************
HeatingServiceVm.ViewModel = function () {
    var self = this;

    self.HeatingStatesBath = ko.observable(HeatingRoomModel.HeatingRoom(false, 0.0, 0.0));
    self.HeatingStatesOffice = ko.observable(HeatingRoomModel.HeatingRoom(false, 0.0, 0.0));
    self.HeatingStatesCentral = ko.observable(false);
    self.ServiceMode = ko.observable(false);

    self.SetHeatingCircuitValveBath = function () {
        HeatingManagementService.GetHeatingStatesBath().then(function (heatingBathStates) {
            self.HeatingStatesBath(heatingBathStates);
            HeatingManagementService.SetHeatingCircuitValveBath(!self.HeatingStatesBath().CircuitValve).then(function (heatingBathStatesInner) {
                self.HeatingStatesBath(heatingBathStatesInner);
            });
        });
    };

    self.SetHeatingCircuitValveOffice = function () {
        HeatingManagementService.GetHeatingStatesOffice().then(function (heatingOfficeStates) {
            self.HeatingStatesOffice(heatingOfficeStates);
            HeatingManagementService.SetHeatingCircuitValveOffice(!self.HeatingStatesOffice().CircuitValve).then(function (heatingOfficeStatesInner) {
                self.HeatingStatesOffice(heatingOfficeStatesInner);
            });
        });
    };

    self.SetCentralPump = function () {
        HeatingManagementService.GetHeatingStatesCentral().then(function (heatingCentralStates) {
            self.HeatingStatesCentral(heatingCentralStates);
            HeatingManagementService.SetCentralPump(!self.HeatingStatesCentral().CentralPump).then(function (heatingCentralStatesInner) {
                self.HeatingStatesCentral(heatingCentralStatesInner);
            });
        });
    };

    self.SetServiceMode = function () {
        HeatingManagementService.GetServiceMode().then(function (heatingServiceMode) {
            self.ServiceMode(heatingServiceMode);
            HeatingManagementService.SetServiceMode(!self.ServiceMode()).then(function (heatingServiceModeInner) {
                self.ServiceMode(heatingServiceModeInner);
            });
        });
    };

    // todo: get/set parameter functionalities
    // todo: timer for refreshing states
}
