﻿// ************************************************************************
// Provides logic for entry room functionalities.
// ************************************************************************

var EntryRoomVm = new Object(); // namespace object

// ************************************************************************
// Creates viewmodel for knockout js.
// ************************************************************************
EntryRoomVm.ViewModel = function () {
    var self = this;

    self.LightsEntryStates = ko.observable(LightsEntryModel.LightsEntry(false, false, false));

    self.SwitchMainLight = function () {
        LightEntryService.GetEntryLightStates().then(function (lightEntryStates) {
            self.LightsEntryStates(lightEntryStates);
            LightEntryService.SwitchMainLight(!self.LightsEntryStates().EntryMainLight).then(function (lightEntryStatesInner) {
                self.LightsEntryStates(lightEntryStatesInner);
            });
        });
    };

    self.SwitchColumnLight = function () {
        LightEntryService.GetEntryLightStates().then(function (lightEntryStates) {
            self.LightsEntryStates(lightEntryStates);
            LightEntryService.SwitchColumnLight(!self.LightsEntryStates().EntryColumnLight).then(function (lightEntryStatesInner) {
                self.LightsEntryStates(lightEntryStatesInner);
            });
        });
    };

    // todo: timer for refreshing states
}
