﻿// ************************************************************************
// Provides logic for office room functionalities.
// ************************************************************************

var OfficeRoomVm = new Object(); // namespace object

// ************************************************************************
// Creates viewmodel for knockout js.
// ************************************************************************
OfficeRoomVm.ViewModel = function () {
    var self = this;

    self.LightsOfficeStates = ko.observable(LightsOfficeModel.LightsOffice(false, false, false, false, false, false, false, false, false, false, false));
    self.HeatingRoomStates = ko.observable(HeatingRoomModel.HeatingRoom(false, 0.0, 0.0));

    self.SwitchBalkLight1 = function () {
        LightOfficeService.GetOfficeLightStates().then(function (lightOfficeStates) {
            self.LightsOfficeStates(lightOfficeStates);
            LightOfficeService.SwitchBalkLight1(!self.LightsOfficeStates().BalkLight1).then(function (lightOfficeStatesInner) {
                self.LightsOfficeStates(lightOfficeStatesInner);
            });
        });
    };

    self.SwitchBalkLight2 = function () {
        LightOfficeService.GetOfficeLightStates().then(function (lightOfficeStates) {
            self.LightsOfficeStates(lightOfficeStates);
            LightOfficeService.SwitchBalkLight2(!self.LightsOfficeStates().BalkLight2).then(function (lightOfficeStatesInner) {
                self.LightsOfficeStates(lightOfficeStatesInner);
            });
        });
    };

    self.SwitchBalkLight5And6 = function () {
        LightOfficeService.GetOfficeLightStates().then(function (lightOfficeStates) {
            self.LightsOfficeStates(lightOfficeStates);
            LightOfficeService.SwitchBalkLight5And6(!self.LightsOfficeStates().BalkLight5And6).then(function (lightOfficeStatesInner) {
                self.LightsOfficeStates(lightOfficeStatesInner);
            });
        });
    };

    self.SwitchBalkLight7And8 = function () {
        LightOfficeService.GetOfficeLightStates().then(function (lightOfficeStates) {
            self.LightsOfficeStates(lightOfficeStates);
            LightOfficeService.SwitchBalkLight7And8(!self.LightsOfficeStates().BalkLight7And8).then(function (lightOfficeStatesInner) {
                self.LightsOfficeStates(lightOfficeStatesInner);
            });
        });
    };

    self.SwitchBalkLight9 = function () {
        LightOfficeService.GetOfficeLightStates().then(function (lightOfficeStates) {
            self.LightsOfficeStates(lightOfficeStates);
            LightOfficeService.SwitchBalkLight9(!self.LightsOfficeStates().BalkLight9).then(function (lightOfficeStatesInner) {
                self.LightsOfficeStates(lightOfficeStatesInner);
            });
        });
    };

    self.SwitchBalkLight10 = function () {
        LightOfficeService.GetOfficeLightStates().then(function (lightOfficeStates) {
            self.LightsOfficeStates(lightOfficeStates);
            LightOfficeService.SwitchBalkLight10(!self.LightsOfficeStates().BalkLight10).then(function (lightOfficeStatesInner) {
                self.LightsOfficeStates(lightOfficeStatesInner);
            });
        });
    };

    self.SwitchBalkLightUpper = function () {
        LightOfficeService.GetOfficeLightStates().then(function (lightOfficeStates) {
            self.LightsOfficeStates(lightOfficeStates);
            LightOfficeService.SwitchBalkLightUpper(!self.LightsOfficeStates().BalkLightUpper).then(function (lightOfficeStatesInner) {
                self.LightsOfficeStates(lightOfficeStatesInner);
            });
        });
    };

    self.SwitchMediaboardLight = function () {
        LightOfficeService.GetOfficeLightStates().then(function (lightOfficeStates) {
            self.LightsOfficeStates(lightOfficeStates);
            LightOfficeService.SwitchMediaboardLight(!self.LightsOfficeStates().MediaBoardLight).then(function (lightOfficeStatesInner) {
                self.LightsOfficeStates(lightOfficeStatesInner);
            });
        });
    };

    self.SwitchCupboardLight = function () {
        LightOfficeService.GetOfficeLightStates().then(function (lightOfficeStates) {
            self.LightsOfficeStates(lightOfficeStates);
            LightOfficeService.SwitchCupboardLight(!self.LightsOfficeStates().CupboardLight).then(function (lightOfficeStatesInner) {
                self.LightsOfficeStates(lightOfficeStatesInner);
            });
        });
    };

    self.GetHeatingRoomStates = function () {
        HeatingManagementService.GetHeatingStatesOffice().then(function (heatingRoomModel) {
            self.HeatingRoomStates(heatingRoomModel);
        });
    };

    // todo: timer for refreshing states
}
